Daemonparts
===========

Daemonparts is a Lua module that provides boilerplate functionality
for scripts that run for a long time as a background service on
unix-like operating systems, also known as 'daemons'.

A lot of this code is conceptionally simple, but is often difficult to
write correctly due to edge cases, or maybe just annoying/tedious to
code. Current features include daemonization, forking child processes,
executing external programs, locating configuration files without
prior filesystem knowledge, a simple retargettable logging subsystem,
and brute-force daemon reload with exec().

Daemonparts builds on
[Lunix](http://25thandclement.com/~william/projects/lunix.html),
and primarly targets Lua 5.3. It is routinely tested on Linux and
NetBSD, but should be portable to any platform supported by Lunix.
[Cqueues](https://25thandclement.com/~william/projects/cqueues.html) is 
also used, but only in the Signals module.

The easiest install method is via
[LuaRocks.](https://luarocks.org/modules/sparked435/daemonparts)

Documentation
-------------

Daemonparts consists of multiple modules all handling different
concerns. All are independant: usage of one doesn't require any
others. Use only the parts you want to use.

 - [Configuration](/code/daemonparts/config.md):
   Locate and load a configuration file
 - [Daemonization](/code/daemonparts/daemonize.md):
   Become a background Process
 - [Output](/code/daemonparts/output.md):
   Simple re-targetable logging subsystem
 - [Process](/code/daemonparts/process.md):
   Fork and interact with child processes, or execute external commands
 - [Signals](/code/daemonparts/signals.md):
   Typical daemon signal handling for SIGTERM and SIGHUP
 - [Recycle](/code/daemonparts/recycle.md):
   Brute force exec() to reload a daemon


Other Resources
---------------

 - [Ldoc Documentation](/code/daemonparts/doc)
 - [SVN Repo](https://svn.zadzmo.org/repo/daemonparts)
 - [Lloyd CI](https://lloyd.zadzmo.org/jobs/ci-daemonparts) (coming soon)
