Recycle Module
==============

'Recycle' performs a brute-force reload of an entire process, by
calling exec() with the same arguments that the script was called with.

I don't anticipate this to find much use, but it keeps being useful in
my projects, so I've included it here.


Usage
-----

First, call setup() when the main arg array is still available:

	local recycle = require 'daemonparts.recycle'
	recycle.setup( arg[0], arg )

Then call exec() at any time:

	recycle.exec()
	
It will appear, to your script, as if os.exit() was called. Except
it restarts, as if just started by the user. The underlying system calls
completely replace everything in memory, freeing all resources - so
the main reason to do this is to guard against leaks.

If an entirely new process is desired - overkill, but then typically
this entire module is overkill - call fork_and_exec() instead. If your
script is running in the foreground, it will detach into the background
as a side effect.
